#include "glu_kernel.h"
#include "glu_kernel_impl.h"

namespace GLU {

Kernel *Kernel::Create(
        int n,      /* matrix size */
        int *ia,    /* row index */
        int *ja,    /* column index */
        float *a,   /* matrix A pointer */
        int nnz,    /* number of non-zeros */
        float *b,   /* vector b pointer */
        float *x,   /* unknowns x pointer */
        std::ostream &out,  /* output stream */
        std::ostream &err)  /* error stream */
{
    return new KernelImpl(n, ia, ja, a, nnz, b, x, out, err);
}

Kernel *Kernel::Create(std::istream &in, std::ostream &out, std::ostream &err)
{
    return new KernelImpl(in, out, err);
}

}; /* namespace GLU */
