#ifndef _KERNELS_H_
#define _KERNELS_H_


__global__ void dummy(const int* __restrict__ sym_c_ptr_dev,
					  const int* __restrict__ sym_r_idx_dev,
					  float* __restrict__ val_dev,
					  const int* __restrict__ l_col_ptr_dev,
					  const int* __restrict__ csr_diag_col_ptr_dev,
					  const int* __restrict__ u_col_idx_dev,
					  const int* __restrict__ u_row_ptr_dev,
					  const int* __restrict__ level_idx_dev,
					  const int* __restrict__ level_ptr_dev,
					  const int level,
                      const int nthreads);

__global__ void RL_LU(const int* __restrict__ sym_c_ptr_dev,
					  const int* __restrict__ sym_r_idx_dev,
					  float* __restrict__ val_dev,
					  const int* __restrict__ l_col_ptr_dev,
					  const int* __restrict__ csr_diag_col_ptr_dev,
					  const int* __restrict__ u_col_idx_dev,
					  const int* __restrict__ u_row_ptr_dev,
					  const int* __restrict__ level_idx_dev,
					  const int* __restrict__ level_ptr_dev,
					  const int level,
                      const int nthreads);

__global__ void LL_LU(const int* __restrict__ sym_c_ptr_dev,
					  const int* __restrict__ sym_r_idx_dev,
					  float* __restrict__ val_dev,
					  const int* __restrict__ l_col_ptr_dev,
					  const int* __restrict__ csr_diag_col_ptr_dev,
					  const int* __restrict__ level_idx_dev,
					  const int* __restrict__ level_ptr_dev,
					  const int level,
                      const int nthreads);

__global__ void LL_LU_new(const int* __restrict__ sym_c_ptr_dev,
					      const int* __restrict__ sym_r_idx_dev,
						  float* __restrict__ val_dev,
					      const int* __restrict__ l_col_ptr_dev,
					      const int* __restrict__ csr_diag_col_ptr_dev,
					      const int* __restrict__ level_idx_dev,
					      const int* __restrict__ level_ptr_dev,
					      const int level,
                          const int nthreads);

__global__ void RL_LU_new(const int* __restrict__ sym_c_ptr_dev,
					      const int* __restrict__ sym_r_idx_dev,
					      float* __restrict__ val_dev,
					      const int* __restrict__ l_col_ptr_dev,
					      const int* __restrict__ csr_diag_col_ptr_dev,
					      const int* __restrict__ u_col_idx_dev,
					      const int* __restrict__ u_row_ptr_dev,
					      const int* __restrict__ level_idx_dev,
					      const int* __restrict__ level_ptr_dev,
					      const int level,
                          const int nthreads);


__global__ void RL(const int* __restrict__ sym_c_ptr_dev,
				   const int* __restrict__ sym_r_idx_dev,
				   float* __restrict__ val_dev,
				   const int* __restrict__ l_col_ptr_dev,
				   const int* __restrict__ csr_diag_col_ptr_dev,
				   const int* __restrict__ u_col_idx_dev,
				   const int* __restrict__ u_row_ptr_dev,
				   const int* __restrict__ level_idx_dev,
				   const int* __restrict__ level_ptr_dev,
				   float* __restrict__ tmpMem,
				   const int N,
				   const int level,
				   const int inLevPos,
				   const int nthreads);

__global__ void RL_perturb(const int* __restrict__ sym_c_ptr_dev,
				   const int* __restrict__ sym_r_idx_dev,
				   float* __restrict__ val_dev,
				   const int* __restrict__ l_col_ptr_dev,
				   const int* __restrict__ csr_diag_col_ptr_dev,
				   const int* __restrict__ u_col_idx_dev,
				   const int* __restrict__ u_row_ptr_dev,
				   const int* __restrict__ level_idx_dev,
				   const int* __restrict__ level_ptr_dev,
				   float* __restrict__ tmpMem,
				   const int N,
				   const int level,
				   const int inLevPos,
				   const int nthreads,
				   const float pert);

#endif
