#ifndef _SYMBOLIC_H_
#define _SYMBOLIC_H_
#include "matrix.h"
#include <vector>
#include <list>
#include <iostream>

class Symbolic_Matrix
{
public:
    int n;
    int nnz;
    int num_lev;
    std::vector<int> sym_c_ptr;
    std::vector<int> sym_r_idx;
    std::vector<int> csr_r_ptr;
    std::vector<int> csr_c_idx;
    std::vector<int> csr_diag_ptr;
    std::vector<float> val;
    std::vector<float> val_bak;
    std::vector<int> l_col_ptr;
    std::vector<int> level_idx;
    std::vector<int> level_size;
    std::vector<int> level_ptr;

    void symbolic(Matrix &A);
    void level_one_by_one();
    void predictLU(Matrix &A);
    void csr();
    void restore();
    
    void U_dependency();
    void W_dependency();
    void W_dependency_csr();
    void W_dependency_csc();
    void remove_duplicates();
    void BFS();
    void restart();

    void U_leveling();
    void U_W_leveling();

    Symbolic_Matrix(std::ostream &out, std::ostream &err): m_out(out), m_err(err) {};

private:
    std::ostream &m_out;
    std::ostream &m_err;
    std::vector< std::list<int> > graph;
    std::vector< std::list<int> > graph_inv;
};


#endif
